﻿using System;
using System.Windows.Forms;
using System.Text;

namespace ListClients
{
    public partial class frmListClients : Form
    {
        public frmListClients()
        {
            InitializeComponent();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Close();
        }

        // An example of iterating through the clients available.
        // ClientListInit initializes the search based on registry
        // entries from a Visma Compact installation. If no local
        // installation exists, use DatabaseSetPath to point to the
        // root database path.
        // The id part ClientNameType should be used when opening
        // the database.
        private void button1_Click(object sender, EventArgs e)
        {
            XORBase5.ClientNameType cl = new XORBase5.ClientNameType();

            // Set the database root path if Compact is not installed
            // XORBase5.DatabaseSetPath(@"\\Server\Visma Compact\Företag");

            int result = XORBase5.ClientListInit(ref cl);

            while( result > 0 )
            {
                listBox1.Items.Add(string.Format("{0}\t - {1}", cl.id, cl.name));

                result = XORBase5.ClientListNext(ref cl);
            }
        }

        // A simple example of finding the id from a selection in the listbox
        // and retrieving a piece of data.
        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            label2.Text = "";

            if( listBox1.SelectedItem == null )
                return;

            string [] listRowItems = listBox1.SelectedItem.ToString().Split(new char[]{'\t',' '});

            if( listRowItems.Length > 0)
            {
                if( XORBase5.DatabaseOpen(listRowItems[0]) == XORBase5.DbOk )
                {
                    StringBuilder orgNo = new StringBuilder();
                    IntPtr fOrgNo = XORBase5.RecordField(XORBase5.CLIENT, "ORGNO");
                    XORBase5.FieldValueString(fOrgNo, orgNo, 64);
                    label2.Text = orgNo.ToString();
                    XORBase5.DatabaseClose();
                }

            }
        }
    }
}
