'
'    Visma Compact 5 API
'
'    Copyright (C) 1996-2010, Visma Spcs AB
'    
'   $Id: XORBase5.vb,v 1.23 2010/10/18 13:08:14 VSW\Dahn_Nil Exp $
'
' Import module for interfacing VB.Net applications to XORBase5.dll
'

Imports System.Runtime.InteropServices
Imports System.Text

Module XORBase5

    ' Database return codes (errors)
    Public Const DbError As Short = -1      ' General error
    Public Const DbOk As Short = 0          ' OK, no error
    Public Const DbNotFound As Short = 1    ' Record not found
    Public Const DbEof As Short = 2         ' End of file
    Public Const DbBof As Short = 3         ' Beginning of file
    Public Const DbDuplicate As Short = 4   ' Primary key already exists

    ' Constants for person types
    Public Const CUSTOM As Short = 1
    Public Const SUPPLY As Short = 2

    ' Constants for number types
    Public Const XORDER As Short = 0
    Public Const XCUSTINVOICE As Short = 1
    Public Const XPURCHASE As Short = 2
    Public Const XSUPPINVOICE As Short = 3
    Public Const XPAY As Short = 4

    ' Constants for invoice status
    Public Const NOTPRINTED As Short = 0
    Public Const PRINTED As Short = 1
    Public Const TRANSFERED As Short = 2
    Public Const PERMANENT As Short = 3
    Public Const NOTREADY As Short = 4

    ' Constants for ledger types
    Public Const FA As Short = 0
    Public Const KN As Short = 1
    Public Const RF As Short = 2
    Public Const AC As Short = 3
    Public Const BE As Short = 4

    ' Constants for XORBASE tables
    Public Const CLIENT As Short = 0
    Public Const ACCOUNT As Short = 1
    Public Const ACCOUNTINGOBJECT As Short = 2  ' Used to be OBJECT
    Public Const BALANCE As Short = 3
    Public Const VOUCHER As Short = 4
    Public Const AUTOCALC As Short = 5          ' Used to be AUTO
    Public Const DEFAULTACCOUNT As Short = 6    ' Used to be DEFAULT
    Public Const TEXT As Short = 7
    Public Const HISTORY As Short = 8
    Public Const PERSON As Short = 9
    Public Const PERSSALES As Short = 10
    Public Const LEDGER As Short = 11
    Public Const INVOICE As Short = 12
    Public Const INVOICEROW As Short = 13
    Public Const ARTICLE As Short = 14
    Public Const ARTSALES As Short = 15
    Public Const ACCYEAR As Short = 16
    Public Const SERIES As Short = 17
    Public Const RELATION As Short = 18
    Public Const ACCCHART As Short = 19
    Public Const SETTING As Short = 20
    Public Const PERSSETTINGS As Short = 21
    Public Const DOCLOG As Short = 22
    Public Const ACCRUAL As Short = 23

    'Constants for default (reserved) accounts
    Public Const DEFVATOUT As Short = 1         ' Sales VAT
    Public Const DEFVATIN As Short = 10         ' Purchase VAT
    Public Const DEFSTOCK As Short = 18         ' Stock
    Public Const DEFYEARRESULT As Short = 19    ' Year results
    Public Const DEFCUSTOMER As Short = 20      ' Accounts receivable
    Public Const DEFFREIGHT As Short = 21       ' Charged freights
    Public Const DEFFEE As Short = 22           ' Invoice fees
    Public Const DEFADJUSTMENT As Short = 23    ' Rounding
    Public Const DEFINTERIN As Short = 24       ' Interest income
    Public Const DEFFINANCE As Short = 25       ' Financial entries
    Public Const DEFSALES As Short = 26         ' Sales
    Public Const DEFPURCHASE As Short = 27      ' Purchase
    Public Const DEFSUPPLIER As Short = 28      ' Accounts payable
    Public Const DEFPAYIN As Short = 29         ' Accounts receivable (bank)
    Public Const DEFCASH As Short = 30          ' Cash
    Public Const DEFINTEROUT As Short = 31      ' Interest expenses
    Public Const DEFCHANGE As Short = 32        ' Adjustments
    Public Const DEFDISCOUNTOUT As Short = 33   ' Discount out
    Public Const DEFDISCOUNTIN As Short = 34    ' Discount in
    Public Const DEFXPROFIT As Short = 35       ' Exchange income
    Public Const DEFXLOSS As Short = 36         ' Exchange loss
    Public Const DEFEXPSALES As Short = 37      ' Export sales
    Public Const DEFEXPSALES2 As Short = 38     ' Import purchases
    Public Const DEFPAYOUT As Short = 39        ' Accounts payable (bank )
    Public Const DEFVAT As Short = 40           ' VAT settle account
    Public Const DEFFREIGHTEXP As Short = 41    ' Export freight account
    Public Const DEFFEEEXP As Short = 42        ' Export fee account
    Public Const DEFYEARRESULTBOOK As Short = 43 ' Year Result (result)
    Public Const DEFFREIGHTEU As Short = 44     ' Export freight account
    Public Const DEFFEEEU As Short = 45         ' Export fee account
    Public Const DEFREVVAT As Short = 46        ' Default account for reversed VAT
    Public Const DEFACCRUEDRECEIVABLE As Short = 47 ' Default account for accrued receivable
    Public Const DEFACCRUEDDEBT As Short = 48    ' Default account for accrued debt


#Region "API functions"

    Public Delegate Function ErrorHandler(ByVal ErrorNumber1 As Integer, ByVal ErrorNumber2 As Integer, ByVal ErrorString As String) As Integer

    Declare Ansi Function DatabaseOpen Lib "XORBASE5.DLL" (ByVal ClientNumber As String) As Integer
    Declare Ansi Sub DatabaseClose Lib "XORBASE5.DLL" ()
    Declare Ansi Sub DatabaseSetPath Lib "XORBASE5.DLL" (ByVal Path As String)
    Declare Ansi Function DatabaseGetPath Lib "XORBASE5.DLL" (ByVal Path As StringBuilder, ByVal StringSize As Integer) As Integer
    Declare Ansi Function DatabaseTableCount Lib "XORBASE5.DLL" () As Integer
    Declare Ansi Sub SetErrorHandler Lib "XORBASE5.DLL" (ByVal ErrorCallback As ErrorHandler)

    Declare Ansi Function TableFieldCount Lib "XORBASE5.DLL" (ByVal TableIndex As Integer) As Integer
    Declare Ansi Function TableRecordCount Lib "XORBASE5.DLL" (ByVal TableIndex As Integer) As Integer
    Declare Ansi Function TableName Lib "XORBASE5.DLL" (ByVal Path As StringBuilder, ByVal StringSize As Integer) As Integer

    Declare Ansi Function RecordCreate Lib "XORBASE5.DLL" (ByVal TableIndex As Integer) As Integer
    Declare Ansi Function RecordFind Lib "XORBASE5.DLL" (ByVal Key As IntPtr) As Integer
    Declare Ansi Function RecordFirst Lib "XORBASE5.DLL" (ByVal TableIndex As Integer, ByVal KeyNumber As Integer) As Integer
    Declare Ansi Function RecordNext Lib "XORBASE5.DLL" (ByVal TableIndex As Integer) As Integer
    Declare Ansi Function RecordPrev Lib "XORBASE5.DLL" (ByVal TableIndex As Integer) As Integer
    Declare Ansi Function RecordLast Lib "XORBASE5.DLL" (ByVal TableIndex As Integer, ByVal KeyNumber As Integer) As Integer
    Declare Ansi Function RecordUpdate Lib "XORBASE5.DLL" (ByVal TableIndex As Integer) As Integer
    Declare Ansi Function RecordAdd Lib "XORBASE5.DLL" (ByVal TableIndex As Integer) As Integer
    Declare Ansi Function RecordDelete Lib "XORBASE5.DLL" (ByVal TableIndex As Integer) As Integer
    Declare Ansi Function RecordField Lib "XORBASE5.DLL" (ByVal TableIndex As Integer, ByVal FieldName As String) As IntPtr
    Declare Ansi Function RecordKey Lib "XORBASE5.DLL" (ByVal TableIndex As Integer, ByVal KeyNumber As Integer) As IntPtr

    Declare Ansi Function FieldLength Lib "XORBASE5.DLL" (ByVal Field As IntPtr) As Integer
    Declare Ansi Function FieldType Lib "XORBASE5.DLL" (ByVal Field As IntPtr) As Integer
    Declare Ansi Function FieldName Lib "XORBASE5.DLL" (ByVal TableIndex As Integer, ByVal FieldIndex As Integer, ByVal StringBuffer As StringBuilder, ByVal StringSize As Integer) As Integer

    Declare Ansi Function FieldAssignDouble Lib "XORBASE5.DLL" (ByVal Field As IntPtr, ByVal value As Double) As Integer
    Declare Ansi Function FieldAssignLong Lib "XORBASE5.DLL" (ByVal Field As IntPtr, ByVal value As Integer) As Integer
    Declare Ansi Function FieldAssignString Lib "XORBASE5.DLL" (ByVal Field As IntPtr, ByVal value As String) As Integer
    Declare Ansi Function FieldAssignBool Lib "XORBASE5.DLL" (ByVal Field As IntPtr, ByVal value As Boolean) As Integer
    Declare Ansi Function FieldAssignDate Lib "XORBASE5.DLL" (ByVal Field As IntPtr, ByVal value As Short) As Integer

    Declare Ansi Function FieldValueDouble Lib "XORBASE5.DLL" (ByVal Field As IntPtr) As Double
    Declare Ansi Function FieldValueLong Lib "XORBASE5.DLL" (ByVal Field As IntPtr) As Integer
    Declare Ansi Function FieldValueBool Lib "XORBASE5.DLL" (ByVal Field As IntPtr) As Boolean
    Declare Ansi Function FieldValueDate Lib "XORBASE5.DLL" (ByVal Field As IntPtr) As Short
    Declare Ansi Function FieldValueString Lib "XORBASE5.DLL" (ByVal Field As IntPtr, ByVal StringBuffer As StringBuilder, ByVal StringSize As Integer) As Integer

    Declare Ansi Function KeyField Lib "XORBASE5.DLL" (ByVal Key As IntPtr, ByVal FieldName As String) As IntPtr

    Declare Ansi Function InvoiceFind Lib "XORBASE5.DLL" (ByVal serieNumber As Integer, ByVal invoiceIndex As Integer, ByVal invoiceNumber As Integer) As Integer
    Declare Ansi Function InvoiceRowFind Lib "XORBASE5.DLL" (ByVal serieNumber As Integer, ByVal invoiceIndex As Integer, ByVal invoiceNumber As Integer, ByVal rowNumber As Integer) As Integer

    Declare Ansi Function InvoiceOpen Lib "XORBASE5.DLL" (ByVal PersNumber As String, ByVal type As Integer, ByVal Status As Integer, ByVal Year As Integer, ByVal Month As Integer, ByVal Day As Integer, ByVal Freight As Double, ByVal Fee As Double) As Integer
    Declare Ansi Function InvoiceAddRow Lib "XORBASE5.DLL" (ByVal ArticleID As String, ByVal ArticleName As String, ByVal AccountNumber As String, ByVal Object1 As String, ByVal Object2 As String, ByVal Unit As String, ByVal Items As Double, ByVal Price As Double, ByVal Discount As Double) As Integer
    Declare Ansi Function InvoiceClose Lib "XORBASE5.DLL" () As Integer

    Declare Ansi Function VoucherFind Lib "XORBASE5.DLL" (ByVal yearNumber As Integer, ByVal series As Integer, ByVal voucherNumber As Integer, ByVal rowNumber As Integer) As Integer

    Declare Ansi Function VoucherOpen Lib "XORBASE5.DLL" (ByVal Series As Integer, ByVal Year As Integer, ByVal Month As Integer, ByVal Day As Integer) As Integer
    Declare Ansi Function VoucherAddRow Lib "XORBASE5.DLL" (ByVal AccountNumber As String, ByVal VoucherText As String, ByVal Object1 As String, ByVal Object2 As String, ByVal amount As Double) As Integer
    Declare Ansi Function VoucherClose Lib "XORBASE5.DLL" () As Integer

    Declare Ansi Function LedgerFind Lib "XORBASE5.DLL" (ByVal serieNumber As Integer, ByVal personType As Integer, ByVal ledgerType As Integer, ByVal ledgerNumber As Integer) As Integer

    Declare Ansi Function LedgerAddCustomerInvoice Lib "XORBASE5.DLL" (ByVal personNumber As String, ByVal year As Integer, ByVal month As Integer, ByVal day As Integer, ByVal amount As Double, ByVal vat As Double, ByVal ledType As Integer, ByVal invoiceNumber As Integer, ByVal update As Integer, ByVal account As String) As Integer
    Declare Ansi Function LedgerAddSupplierInvoice Lib "XORBASE5.DLL" (ByVal personNumber As String, ByVal suppliersInvoiceNo As String, ByVal year As Integer, ByVal month As Integer, ByVal day As Integer, ByVal amount As Double, ByVal vat As Double, ByVal ledType As Integer, ByVal update As Integer, ByVal account As String) As Integer
    Declare Ansi Sub DocumentAddSupplierInvoice Lib "XORBASE5.DLL" (ByVal filePath As String, ByVal storeDocument As Integer)

    Declare Ansi Function GetReservedAccount Lib "XORBASE5.DLL" (ByVal DefaultNumber As Integer, ByVal AccountNumber As StringBuilder, ByVal StringSize As Integer) As Integer
    Declare Ansi Function GetStandardText Lib "XORBASE5.DLL" (ByVal TextNumber As Integer, ByVal TextString As StringBuilder, ByVal StringSize As Integer) As Integer

    Declare Ansi Function PersonFind Lib "XORBASE5.DLL" (ByVal personType As Integer, ByVal personID As String) As Integer

    ' Add a person
    Declare Ansi Function PersonAdd Lib "XORBASE5.DLL" ( _
        ByVal PersonType As Integer, _
        ByVal PersonNumber As String, _
        ByVal PersonName As String, _
        ByVal Group As String, _
        ByVal Address1 As String, _
        ByVal Address2 As String, _
        ByVal Address3 As String, _
        ByVal Address4 As String, _
        ByVal PhoneNumber As String, _
        ByVal FaxNumber As String, _
        ByVal Reference As String, _
        Optional ByVal TermsOfPayment As Integer = -1, _
        Optional ByVal TermsOfDelivery As Integer = -1, _
        Optional ByVal WayOfDelivery As Integer = -1) As Integer

    Declare Ansi Function ArticleFind Lib "XORBASE5.DLL" (ByVal ArticleNumber As String) As Integer

    ' Add an article
    Declare Ansi Function ArticleAdd Lib "XORBASE5.DLL" ( _
        ByVal ArticleNumber As String, _
        ByVal ArticleName As String, _
        ByVal Group As String, _
        ByVal ItemsInStock As Double, _
        ByVal OrderPoint As Double, _
        ByVal Price As Double, _
        ByVal PurchasePrice As Double) As Integer

    ' Find an object
    Declare Ansi Function ObjectFind Lib "XORBASE5.DLL" (ByVal ObjectID As String) As Integer

    ' Add an object
    Declare Ansi Function ObjectAdd Lib "XORBASE5.DLL" ( _
        ByVal objectType As Integer, _
        ByVal ObjectID As String, _
        ByVal Name As String, _
        ByVal SpanYear As Integer) As Integer

    Declare Ansi Function DueDateCalc Lib "XORBASE5.DLL" (ByVal TermsOfPayment As String, ByVal StartDate As Short) As Short

#Region "Date functions"
    ' -----------------------------------
    ' Date functions
    ' -----------------------------------
    Declare Ansi Function DateSystem Lib "XORBASE5.DLL" () As Short
    Declare Ansi Function YMDToDate Lib "XORBASE5.DLL" (ByVal year As Integer, ByVal mon As Integer, ByVal day As Integer, ByVal check As Integer) As Short
    Declare Ansi Function FirstDayOfWeek Lib "XORBASE5.DLL" (ByVal year As Integer) As Short
    Declare Ansi Function DayOfWeek Lib "XORBASE5.DLL" (ByVal julianDate As Short) As Short
    Declare Ansi Function BeginWeek Lib "XORBASE5.DLL" (ByVal julianDate As Short) As Short
    Declare Ansi Function EndWeek Lib "XORBASE5.DLL" (ByVal julianDate As Short) As Short
    Declare Ansi Function EndWorkWeek Lib "XORBASE5.DLL" (ByVal julianDate As Short) As Short
    Declare Ansi Function DayOfYear Lib "XORBASE5.DLL" (ByVal julianDate As Short) As Short
    Declare Ansi Function BeginYear Lib "XORBASE5.DLL" (ByVal julianDate As Short) As Short
    Declare Ansi Function EndYear Lib "XORBASE5.DLL" (ByVal julianDate As Short) As Short
    Declare Ansi Function BeginMon Lib "XORBASE5.DLL" (ByVal julianDate As Short) As Short
    Declare Ansi Function EndMon Lib "XORBASE5.DLL" (ByVal julianDate As Short) As Short
    Declare Ansi Function Year Lib "XORBASE5.DLL" (ByVal julianDate As Short) As Integer
    Declare Ansi Function Month Lib "XORBASE5.DLL" (ByVal julianDate As Short) As Integer
    Declare Ansi Function Day Lib "XORBASE5.DLL" (ByVal julianDate As Short) As Integer
    Declare Ansi Function Week Lib "XORBASE5.DLL" (ByVal julianDate As Short) As Integer
    Declare Ansi Function GetYearNo Lib "XORBASE5.DLL" (ByVal julianDate As Short) As Integer
    Declare Ansi Function IsDateLocked Lib "XORBASE5.DLL" (ByVal julianDate As Short) As Integer


#End Region

#Region "Misc functions"
    Declare Ansi Function ExportSieFile Lib "XORBASE5.DLL" (ByVal FileName As String, Optional ByVal Level As Integer = 4, Optional ByVal julianDate As Short = 0) As Integer
    Declare Ansi Function ImportSieFile Lib "XORBASE5.DLL" (ByVal FileName As String) As Integer

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi, Pack:=4)> _
    Structure ClientNameType
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=16)> Public id As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=48)> Public name As String
    End Structure

    Declare Ansi Function ClientListInit Lib "XORBASE5.DLL" (<[In](), Out()> ByRef clientName As ClientNameType) As Integer
    Declare Ansi Function ClientListNext Lib "XORBASE5.DLL" (<[In](), Out()> ByRef clientName As ClientNameType) As Integer

#End Region

#End Region

End Module
